#define BOOL(x)                    COLUMN("bit", int, x, 0, 0)
#define BOOL_ARRAY(x, items)       COLUMN_ARRAY("bit", int, x, 0, 0, items)
#define BOOL_(x)                   COLUMN_("bit", int, x, 0, 0)
#define BOOL_ARRAY_(x, items)      COLUMN_ARRAY_("bit", int, x, 0, 0, items)

#define INT(x)                     COLUMN("integer", int, x, 0, 0)
#define INT_ARRAY(x, items)        COLUMN_ARRAY("integer", int, x, 0, 0, items)
#define INT_(x)                    COLUMN_("integer", int, x, 0, 0)
#define INT_ARRAY_(x, items)       COLUMN_ARRAY_("integer", int, x, 0, 0, items)

#define DOUBLE(x)                  COLUMN("double precision", double, x, 0, 0)
#define DOUBLE_ARRAY(x, items)     COLUMN_ARRAY("double precision", double, x, 0, 0, items)
#define DOUBLE_(x)                 COLUMN_("double precision", double, x, 0, 0)
#define DOUBLE_ARRAY_(x, items)    COLUMN_ARRAY_("double precision", double, x, 0, 0, items)

#define DATE(x)                    COLUMN("datetime", Date, x, 0, 0)
#define DATE_ARRAY(x, items)       COLUMN_ARRAY("datetime", Date, x, 0, 0, items)
#define DATE_(x)                   COLUMN_("datetime", Date, x, 0, 0)
#define DATE_ARRAY_(x, items)      COLUMN_ARRAY_("datetime", Date, x, 0, 0, items)

#define TIME(x)                    COLUMN("datetime", Time, x, 0, 0)
#define TIME_ARRAY(x, items)       COLUMN_ARRAY("datetime", Time, x, 0, 0, items)
#define TIME_(x)                   COLUMN_("datetime", Time, x, 0, 0)
#define TIME_ARRAY_(x, items)      COLUMN_ARRAY_("datetime", Time, x, 0, 0, items)

#define STRING(x, n)               COLUMN(OleDBTextType(n), String, x, n, 0)
#define STRING_ARRAY(x, n, items)  COLUMN_ARRAY(OleDBTextType(n), String, x, n, 0, items)
#define STRING_(x, n)              COLUMN_(OleDBTextType(n), String, x, n, 0)
#define STRING_ARRAY_(x, n, items) COLUMN_ARRAY_(OleDBTextType(n), String, x, n, 0, items)

#define PRIMARY_KEY                INLINE_ATTRIBUTE("primary key")
#define KEY                        INLINE_ATTRIBUTE("key")
#define NOT_NULL                   INLINE_ATTRIBUTE("not null")
#define IDENTITY                   INLINE_ATTRIBUTE("identity")

#define INDEX                      ATTRIBUTE("create index IDX_@x on @t(@c);", \
                                             "drop index IDX_@x;")
#define UNIQUE                     ATTRIBUTE("create unique index UNQ_@x on @t(@c);", \
	                                         "drop index UNQ_@x;")
#define REFERENCES(x)              ATTRIBUTE("alter table @t add constraint FK_@x foreign key "\
                                             "(@c) references @s" #x ";",\
                                             "alter table @t drop constraint FK_@x;")

#define TIMESTAMP(ts)              SCHEMA("-- " ts "\n\n", NULL)

#define COMMENT(txt)               SCHEMA("-- " #txt "\n", NULL)

#include <Sql/sch_model.h>

#undef INT
#undef INT_ARRAY
#undef INT_
#undef INT_ARRAY_

#undef DOUBLE
#undef DOUBLE_ARRAY
#undef DOUBLE_
#undef DOUBLE_ARRAY_

#undef DATE
#undef DATE_ARRAY
#undef DATE_
#undef DATE_ARRAY_

#undef DATETIME
#undef DATETIME_ARRAY
#undef DATETIME_
#undef DATETIME_ARRAY_

#undef STRING
#undef STRING_ARRAY
#undef STRING_
#undef STRING_ARRAY_

#undef PRIMARY_KEY
#undef KEY
#undef NOT_NULL
#undef IDENTITY

#undef INDEX

#undef UNIQUE

#undef TIMESTAMP
#undef COMMENT
